package com.oreilly.jent.hibernate;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.util.List;

import junit.framework.TestCase;

public class TestProfessors extends TestCase {

   /**
    * Load a professor, verifies simple properties.
    * @throws Exception
    */
   public void testGetProf() throws Exception {
      Professor p = Facade.getProfessor(new Long(3));
      assertNotNull(p);
      assertEquals("Albert", p.getFirstName());
      assertEquals("Einstein", p.getLastName());
   }


   /**
    * Demonstrates loading value-type collections (non-unique values), in this case, email addresses.
    * @throws Exception
    */
   public void testEmails() throws Exception {
      Professor p = Facade.getProfessorWithEmails(new Long(3));
      assertNotNull(p);
      assertEquals("Albert", p.getFirstName());
      assertEquals("Einstein", p.getLastName());
      assertNotNull(p.getEmails());
      assertEquals(1, p.getEmails().size());
      assertEquals("al@einsteinbros.com",(String)p.getEmails().iterator().next());
   }

   /**
    * Verifies the one-to-many relationship to UniversityClass.
    * @throws Exception
    */
   public void testProfClasses() throws Exception {
      Professor p = Facade.getProfessor(new Long(3));
      assertNotNull(p);
      assertNotNull(p.getClasses());
      assertEquals(2, p.getClasses().size());
      assertEquals("Comparative Lit", ((UniversityClass)p.getClasses().iterator().next()).getName());
   }

   /**
    * Demonstrates creating a new instance of Professor and saving it to the database.
    * @throws Exception
    */
   public void testAddProfessor() throws Exception {
      List profs = Facade.getProfessors();
      assertEquals(2, profs.size());
      Professor p = new Professor();
      p.setFirstName("Blaise");
      p.setLastName("Pascal");
      p.setDegree("MBA");
      Facade.save(p);
      profs = Facade.getProfessors();
      assertEquals(3, profs.size());
      Facade.delete(p);
      profs = Facade.getProfessors();
      assertEquals(2, profs.size());
   }

   /**
    * Demonstrates loading Professors via a parameterized query.
    * @throws Exception
    */
   public void testQueryByDegree() throws Exception {
      List profs = Facade.getProfessors();
      assertEquals(2, profs.size());
      Professor p = new Professor();
      p.setFirstName("Blaise");
      p.setLastName("Pascal");
      p.setDegree("MBA");
      Facade.save(p);
      profs = Facade.getProfessors();
      assertEquals(3, profs.size());
      List phds = Facade.getProfessorsByDegree("Ph.D.");
      assertEquals(2, phds.size());
      Facade.delete(p);
   }
}
